package org.eclipse.jdt.internal.compiler.lookup;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import org.eclipse.jdt.internal.compiler.lookup.BoundSet;
import org.eclipse.jdt.internal.compiler.lookup.InferenceContext18;
import org.eclipse.jdt.internal.compiler.lookup.InferenceFailureException;
import org.eclipse.jdt.internal.compiler.lookup.InferenceVariable;
import org.eclipse.jdt.internal.compiler.lookup.ReductionResult;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;

abstract class ConstraintFormula extends ReductionResult {
  static final List<InferenceVariable> EMPTY_VARIABLE_LIST = Collections.emptyList();
  
  static final org.eclipse.jdt.internal.compiler.lookup.ConstraintFormula[] NO_CONSTRAINTS = (org.eclipse.jdt.internal.compiler.lookup.ConstraintFormula[])new org.eclipse.jdt.internal.compiler.lookup.ConstraintTypeFormula[0];
  
  static final char LEFT_ANGLE_BRACKET = '⟨';
  
  static final char RIGHT_ANGLE_BRACKET = '⟩';
  
  public abstract Object reduce(InferenceContext18 paramInferenceContext18) throws InferenceFailureException;
  
  Collection<InferenceVariable> inputVariables(InferenceContext18 context) {
    return EMPTY_VARIABLE_LIST;
  }
  
  Collection<InferenceVariable> outputVariables(InferenceContext18 context) {
    Set<InferenceVariable> variables = new HashSet<>();
    this.right.collectInferenceVariables(variables);
    if (!variables.isEmpty())
      variables.removeAll(inputVariables(context)); 
    return variables;
  }
  
  public boolean applySubstitution(BoundSet solutionSet, InferenceVariable[] variables) {
    for (int i = 0; i < variables.length; i++) {
      InferenceVariable variable = variables[i];
      TypeBinding instantiation = solutionSet.getInstantiation(variables[i], null);
      if (instantiation == null)
        return false; 
      this.right = this.right.substituteInferenceVariable(variable, instantiation);
    } 
    return true;
  }
  
  protected void appendTypeName(StringBuffer buf, TypeBinding type) {
    if (type instanceof org.eclipse.jdt.internal.compiler.lookup.CaptureBinding18) {
      buf.append(type.toString());
    } else {
      buf.append(type.readableName());
    } 
  }
}
